//Eugene Debs, Nov 21, 2006
//Shake Forum, discussions.apple.com
image Laser(
image Input=0,
int width = GetDefaultWidth(),
int height = GetDefaultHeight(),
float sWidth=8,
float eWidth=8,
float blur=1,
float sGlow=sWidth*5,
float eGlow=eWidth*5,
float bias=.5,
float red1=1,
float green1=.9,
float blue1=0,
float red2=.1,
float green2=1,
float blue2=0,
float roundness=1,
float pos1X = width*.3,
float pos1Y = height*.3,
float pos2X = width*.66,
float pos2Y = height*.66
)
{
bolt = NGLRender(width, height, 1,"
// initial calculations
curve float a= atan2d(pos2Y-pos1Y, pos2X-pos1X);
curve float dist = distance(pos2X,pos2Y, pos1X, pos1Y);

//Position
nglPushMatrix();
//nglTranslatef(-pos1X,-pos1Y,0.0f);
nglRotatef(a ,0.0f,0.0f,1.0f);
nglTranslatef(pos1X,pos1Y,0.0f);	

//Draw main poly at origin
nglBegin(NGL_POLYGON);
nglColor4f(1,1,1,1);
nglVertex2f(0,sWidth/2);
nglVertex2f(-sWidth/4*roundness,sWidth/2.5*roundness);
nglVertex2f(-sWidth/3*roundness,sWidth/3*roundness);
nglVertex2f(-sWidth/2.5*roundness,sWidth/4*roundness);
nglVertex2f(-sWidth/2*roundness,0);
nglVertex2f(-sWidth/2.5*roundness,-sWidth/4*roundness);
nglVertex2f(-sWidth/3*roundness,-sWidth/3*roundness);
nglVertex2f(-sWidth/4*roundness,-sWidth/2.5*roundness);
nglVertex2f(0,-sWidth/2);
nglVertex2f(dist,-eWidth/2);
nglVertex2f(dist+eWidth/4*roundness,-eWidth/2.5*roundness);
nglVertex2f(dist+eWidth/3*roundness,-eWidth/3*roundness);
nglVertex2f(dist+eWidth/2.5*roundness,-eWidth/4*roundness);
nglVertex2f(dist+eWidth/2*roundness,0);
nglVertex2f(dist+eWidth/2.5*roundness,eWidth/4*roundness);
nglVertex2f(dist+eWidth/3*roundness,eWidth/3*roundness);
nglVertex2f(dist+eWidth/4*roundness,eWidth/2.5*roundness);
nglVertex2f(dist,eWidth/2);
nglEnd();
nglPopMatrix();

"
);
RGrad1 = RGrad(Input.width, Input.height, 1, sGlow<eGlow?pos2X:pos1X, sGlow<eGlow?pos2Y:pos1Y, 1, 0, distance(pos2X,pos2Y,pos1X, pos1Y), bias, 1, 1, 1, 1, 0, 0, 0, 0, min(sGlow,eGlow)/max(sGlow,eGlow), 0);
DilateErode1 = DilateErode(bolt, "rgba", -max(eWidth,sWidth)/6, xPixels/GetDefaultAspect(), 0, 0, 0);
Bytes1 = Bytes(bolt,2);
IBlur1 = IBlur(Bytes1, RGrad1, max(eWidth,sWidth)*10*blur, 
xPixels/GetDefaultAspect(), 0, "gauss", xFilter, 5, 1, "A", "rgba", 0);
IBlur2 = IBlur(Bytes1, RGrad1, max(eWidth,sWidth)*2*blur, 
xPixels/GetDefaultAspect(), 0, "gauss", xFilter, 5, 1, "A", "rgba", 0);
Mult1_clone1 = Mult(bolt, red1, green1, blue1, 1, Mult1.depth);
Blur2 = Blur(DilateErode1, 10, xPixels/GetDefaultAspect(), 0, "gauss", xFilter, "rgba");
Over2 = Over(IBlur2, IBlur1, 1, 0, 0);
Bytes2 = Bytes(Over2,1);
Brightness2 = Brightness(Bytes2, 1.5);
Mult1 = Mult(Blur2, red1, green1, blue1, 1, 1);
Mult2 = Mult(Brightness2, red2, green2, blue2, 1, 1);
Saturation1 = Saturation(Mult1, 0.5);
Over1 = Over(Saturation1, Mult1_clone1, 1, 0, 0);
Blur1 = Blur(Over1, 5, xPixels/GetDefaultAspect(), 0, "gauss", xFilter, "rgba");
Under1 = Under(Mult2, Blur1, 1, 0, 0);

Over1=Over(Under1,Input);
return Over1;
}
